/*
Continuous Testing Toolkit
Copyright (C) 2009 Paul R. Holser, Jr.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

package org.infinitest.toolkit.runners;

import static java.util.Arrays.*;

import org.junit.internal.builders.AllDefaultPossibilitiesBuilder;
import org.junit.runner.Runner;
import org.junit.runners.model.RunnerBuilder;

class AllDefaultPossibilitiesExceptAnnotationRunnerBuilder extends AllDefaultPossibilitiesBuilder {
    AllDefaultPossibilitiesExceptAnnotationRunnerBuilder(boolean canUseSuiteMethod) {
        super(canUseSuiteMethod);
    }

    @Override
    public Runner runnerForClass(Class<?> testClass) {
        for (RunnerBuilder each : asList(ignoredBuilder(), suiteMethodBuilder(), junit3Builder(), junit4Builder())) {
            Runner runner = each.safeRunnerForClass(testClass);
            if (runner != null)
                return runner;
        }

        return null;
    }
}
